<?php
if(empty($_SERVER['DOCUMENT_ROOT']))
{
	$is_cli=true;
	$_SERVER['DOCUMENT_ROOT']='/usr/local/esia/public_html/';
}

$path = rtrim ($_SERVER['DOCUMENT_ROOT'],'/');
include_once $path.'/esia.conf.php';
include_once $path.'/Model_esia.php';
include_once $path.'/Model_adm.php';
include_once $path.'/plugin/report/Model_Report.php';

if(!$is_cli)
{
	include_once '/usr/local/esia/public_html/common.php';
}
$SHORT_OPTS="a:i:s:e:l:";
$LONG_OPTS=array("action:","id:","start:","end:","language:");

if((isset($_POST['blockid']))&&!empty($_POST['blockid'])) // Lors de la modification du bloc
{
	$idInclude= $_POST['blockid'];
	$action= $_GET['action'];
}
elseif((isset($_GET['id'])) &&!empty($_GET['id'])) // Lors de l'ajout du bloc
{
	$idInclude=$_GET['id'];
	$action=$_GET['action'];
}
else // Lors de l'appel par repor_generate.php
{
	$options = getopt($SHORT_OPTS, $LONG_OPTS);

	$action	  = getParam($options,"action","a");
	$idInclude= getParam($options,"id","i");
	$start	  = getParam($options,"start","s");
	$end	  = getParam($options,"end","e");
	$language = getParam($options,"language","l");

	include $path.'/plugin/report/lang/'.$language.'.php';
	include $path.'/lang/'.$language.'/common_plugin_name.php';

	try
	{
		$dbconnection = new PDO('pgsql:host='.DB_HOST.';port='.DB_PORT.';dbname='.DB_NAME, DB_USERNAME, DB_PWD);
		$dbconnection->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_WARNING);
	}
	catch(Exception $e)
	{
		echo 'PDO SQL ERROR: '.$e->getMessage().'<br />';
		echo 'N° : '.$e->getCode();
	}
}

$query=Model_Report::getReportIncludeBlock($dbconnection,$idInclude);
$query= $query[0];

if($action=="generate")
{
	$param = json_decode($query['include_parameter'],true);

	echo '<div class="clear"></div>';
	echo '<section class="blockView">
          	<div class="blockView_title">
          		<h3 style="text-align:'.$param['title']['style']['text-align'].';
						font-size:'.$param['title']['style']['font-size'].';
						color:'.$param['title']['style']['color'].'"
						><p>'.$param['title']['text'].'</p></h3>
        	</div>
        	<div class="pad">
          		<p style="text-align:'.$param['description']['style']['text-align'].';
						font-size:'.$param['description']['style']['font-size'].'"
							>'.$param['description']['text'].'</p>';
	echo '<table class="tab">
           	<thead>
             <tr valign="top">';

	if($param['affiche_groupNoeud']==true)
	{
		echo '<th><p>'.$lang['REPORT_DEVICE_GROUP_NAME'].'</p></th>';
	}
	echo '<th><p>'.$lang['REPORT_DEVICE_NAME'].'</p></th>';
        if($param['affiche_technical_name']==true)
        {
                 echo '<th><p>'.$lang['REPORT_TECHNICAL_NAME'].'</p></th>';
        }
	if($param['affiche_ip']==true)
	{
		echo '<th><p>'.$lang['REPORT_IP_ADD'].'</p></th>';
	}
	echo '<th><p>'.$lang['REPORT_SERVICE_NAME'].'</p></th>';
	echo '<th><p>'.$lang['REPORT_ERROR_TYPE'].'</p></th>';
	if($param['affiche_message']==true)
	{
		echo '<th><p>'.$lang['REPORT_HAPPEN_MESSAGE'].'</p></th>';
	}
	echo '<th><p>'.$lang['REPORT_TIME'].'</p></th>';
	if($param['affiche_time_end']==true)
	{
		echo '<th><p>'.$lang['REPORT_HAPPEN_TIME_ACQUITTE'].'</p></th>';
	}
	if($param['affiche_duree']==true)
	{
		echo '<th><p>'.$lang['REPORT_DURING'].'</p></th>';
	}

	echo '</tr>';
	echo '</thead>';
	echo '<tbody>';

	if($param['type']=="service")
	{
		foreach ($param['serviceid'] as $i)
		{
			$query = Model_Report::getEsiaErrorServiceId($dbconnection,$i,$start,$end);

			if(!empty($query)&& $query!=null)
			{
				CreateTabIncident($query,$lang,$param);
			}
			else
			{
				$value = Model_esia::getServices($dbconnection,null,$i);
				$value = $value[0];
				$common_name = Model_esia::getCommonName($lang, $value['name'], $value['check_plugin_name']);
				echo "<tr><td colspan='9'><p> ".$lang['REPORT_NO_INCIDENT']." ".$value['device_name']." ".$common_name.".</p></td></tr>";
			}
		}
		echo '</tbody></table></div></section>';
	}
	elseif($param['type']=="noeud" || $param['type']=="groupenoeud")
	{
		$tab_id_node = array();
		if(is_null($user)==false)
		{
			$tab_id_node=nodeOrGroupNode($dbconnection,$param,$user->getId());
		}
		else
		{
			$report_user = Model_Report::getOwnerCanevas($dbconnection,$query['include_canevas_id']);
			$iduser = $report_user;
			$tab_id_node=nodeOrGroupNode($dbconnection,$param,$iduser[0]);
		}

		$no_incidents_html = '';
		foreach ($tab_id_node as $i)
		{
			$query = Model_Report::getEsiaErrorNoeudId($dbconnection,$i['id'],$start,$end);
			if(!empty($query)&& $query!=null)
			{
				CreateTabIncident($query,$lang,$param);
			}
			else
			{
				$value = Model_esia::getServices($dbconnection,$i['id']);
				if(empty($value)){
					$node=Model_esia::InstanceNode($dbconnection,$i['id']);
					$nodeName = $node->getName();
				}
				else{
					$value = $value[0];
					$common_name = Model_esia::getCommonName($lang, $value['name'], $value['check_plugin_name']);
					$nodeName = $value['device_name'];
				}
				$no_incidents_html .="<tr><td colspan='9'><p> ".$lang['REPORT_NO_INCIDENT']."  ".$nodeName."   ".$common_name.". </p></td></tr>";
			}
		}
		echo $no_incidents_html;
		echo '</tbody></table></div></section>';
	}
}
elseif($action=="update")
{
	$template_path = $path.'/plugin/report/templates';
	$param = json_decode($query['include_parameter'],true);

	$rightWriting=$_GET['writingright'];
	if(!isset($rightWriting))
	{
		$rightWriting=$_POST['writingright'];
	}
	$smarty->assign('rightWriting',$rightWriting);

	$smarty->assign('block',$query);
	$smarty->assign('param',$param);
	$taille = explode("px", $param['title']['style']['font-size']);
	$smarty->assign('TaillePoliceTitle',$taille[0]);
	$taille = explode("px", $param['description']['style']['font-size']);
	$smarty->assign('TaillePoliceDescr',$taille[0]);
	$smarty->assign('AlignTilte',$param['title']['style']['text-align']);
	$smarty->assign('AlignDesc',$param['description']['style']['text-align']);

	if(isset($_POST['blockid'])&&!empty($_POST['blockid']))
	{
		try
		{
			// Param Title
			$param['title']['text']=$_POST["blockname"];
			$TaillePoliceTitle = $_POST["namesize"];
			$param['title']['style']['font-size']=$TaillePoliceTitle."px";
			$param['title']['style']['text-align']=$_POST["nameposition"];
			$param['title']['style']['color']=$_POST["blockcolor"];

			// Param Descr
			$param['description']['text']=$_POST["blockdescription"];
			$TaillePoliceDescr=$_POST["blocksize"];
			$param['description']['style']['font-size']=$TaillePoliceDescr."px";
			$param['description']['style']['text-align']=$_POST["desciptionposition"];

			// Service & Noeud
			if($param['type']=='service')
			{
				$param['nodeid']=$_POST['nodes'];
				$param['serviceid']=$_POST['services'];
			}
			elseif ($param['type']=='noeud')
			{
				$param['nodeid']=$_POST['nodes'];
			}
			else
			{
				$param['groupnodeid']=$_POST['groupnodes'];
			}

			// Affichage colonne
                        $param['affiche_technical_name']=$_POST['technical_name'];
			$param['affiche_message']=$_POST['messageError'];
			$param['affiche_ip']=$_POST['add_ip'];
			$param['affiche_time_end']=$_POST['time_end'];
			$param['affiche_duree']=$_POST['duree'];
			$param['affiche_groupNoeud']=$_POST['groupNoeud'];

			// Affichage Erreur
			$param['affiche_warning']=$_POST['levelWarning'];
			$param['affiche_critical']=$_POST['levelCritical'];
			$param['affiche_unknown']=$_POST['levelUnknown'];

			$paramSave = json_encode($param);

			$query=Model_Report::getReportIncludeBlock($dbconnection,$_POST['blockid']);
			$query= $query[0];

			Model_Report::UpdtReportIncludeBlock($dbconnection,$_POST['blockid'],$query['include_block_id'],$query['include_canevas_id'],$query['include_position'],$paramSave);
			$smarty->assign('l_success',$lang['UPDATE_DASHBOARD_SUCCESS']);
		}
		catch (EsiaDbException $e)
		{
			$smarty->assign('l_error',$e->getMessage());
		}
		catch (Exception $e)
		{
			$smarty->assign('l_error',$e->getMessage());
		}

		$smarty->assign('block',$query);
		$smarty->assign('param',$param);
		$taille = explode("px", $param['title']['style']['font-size']);
		$smarty->assign('TaillePoliceTitle',$taille[0]);
		$taille = explode("px", $param['description']['style']['font-size']);
		$smarty->assign('TaillePoliceDescr',$taille[0]);
		$smarty->assign('AlignTilte',$param['title']['style']['text-align']);
		$smarty->assign('AlignDesc',$param['description']['style']['text-align']);
	}

	$listnode = array();
	//Récupération des services
	if($param['type']=="service")
	{
		if(!empty($param['serviceid']))
		{
			$services = Model_esia::getServices($dbconnection,null,$param['serviceid']);
			foreach($services as $ser)
			{
				if(!in_array($ser['device_id'],$listnode))
					$listnode[]=$ser['device_id'];
			}
			foreach($services as $ser)
			{
				$listservice[]=$ser['id'];
			}
		}
		$smarty->assign('serviceid',$listservice);

		$nodes = Model_esia::getNodeList($dbconnection,$user->getId(),null,Model_esia::NODE_INSTANCE);
		$list=array();

		foreach($nodes as $node)
		{
			$selected='no';
			if(in_array($node->getId(),$listnode))
			{
				$selected='yes';
			}
			$list[]=array('id'=>$node->getId(),
					'name'=>$node->getGroup().'>'.$node->getName(),
					'selected'=>$selected
			);
		}
	}
	elseif($param['type']=="noeud")
	{
		//Récupération des noeuds
		$nodes = Model_esia::getNodeList($dbconnection,$user->getId(),null,Model_esia::NODE_INSTANCE);
		$list=array();
		foreach($nodes as $node)
		{
			$selected='no';
			if(in_array($node->getId(),$param['nodeid']))
			{
				$selected='yes';
			}
			$list[]=array('id'=>$node->getId(),
					'name'=>$node->getGroup().'>'.$node->getName(),
					'selected'=>$selected

			);
		}
	}
	else
	{
		$list = Model_esia::getNodeGroupHierarchyByUser($dbconnection,$user->getId());
		$list_group_node=array();
		foreach($list as $node)
		{
			$selected='no';
			if(in_array($node['id'],$param['groupnodeid']))
			{
				$selected='yes';
			}

			$list_group_node[]=array('id'=>$node['id'],
					'name'=>$node['name'],
					'selected'=>$selected);
		}
	}
	$smarty->assign('adm_list_node', $list);
	$smarty->assign('adm_list_group_node', $list_group_node);
	$smarty->assign('action','update');
	$smarty->display($template_path.'/incident.html');
}
elseif($action =="getservice")
{
	$template_path = $path.'/plugin/report/templates';
	if(isset($_GET['nodeid']))
	{
		$tablenodeid = json_decode($_GET['nodeid']);
		$list=array();
		foreach($tablenodeid as $nodeid)
		{
			$node = Model_esia::InstanceNode($dbconnection, $nodeid);
			if($user->getAccess($dbconnection, "device_view",$node->getName())==1)
			{
				$services = Model_esia::getServices($dbconnection,$node->getId());
				foreach ($services as $service)
				{
					$common_name = Model_esia::getCommonName($lang, $service['name'],$service['check_plugin_name']);
					$list[$service['id']]=$node->getName().' > '.$common_name;
				}
			}
		}
		echo json_encode($list);
		exit(0);
	}
}

/**
 * @brief fais la difference entre noeud et groupe de noeud et retourne les bons param's
 * @detail retourne un array contenant les paramètres utlisés qu'importe que ce soit un noeud ou groupe de noeud
 * @param PDO $dbconnection
 * @param array $param contient les param du block
 * @retval unknown[][]|NULL[][]
 * @throw void
 */

function nodeOrGroupNode($dbconnection,$param,$userid)
{
	$tab_id_node=array();
	if($param['type']=="noeud")
	{
		foreach($param['nodeid'] as $val)
		{
			$tab_id_node[$val] = array('id'=>$val);
		}
		$tab_id_node = array_values($tab_id_node);
	}
	else
	{
		foreach ($param['groupnodeid'] as $groupnode )
		{
			$tab_group_node = Model_esia::getAllNodeofGroup($dbconnection,$userid,$groupnode);
			//$tab_group_node = Model_esia::getNodeList($dbconnection,null,$groupnode,$t_return = Model_esia::NODE_INSTANCE);
			foreach ($tab_group_node as $node)
			{
				$tab_id_node[] = array('id'=>$node->getId(),'parent'=>$node->getGroup(),'idgroup'=>$node->getGroupId());
			}
			$tab_id_node = mergeGroupeNames($tab_id_node,'id','parent');
		}
	}
	return $tab_id_node;
}

function mergeGroupeNames($list,$node_id_key,$group_name_key){
	$mergegroupnodes = array();
    //trie par identifiant de service
	foreach($list as $node){
		$mergegroupnodes[$node[$node_id_key]][] = $node;
	}
	$multigroupnodes = array();
	foreach($mergegroupnodes as $key => $arr)
	{
	    $groups_arr = array_unique(array_column($arr, $group_name_key));
		sort($groups_arr);
		$node = current($arr);
		$node[$group_name_key] = implode("\n",$groups_arr);
		$multigroupnodes[] = $node;
	}
	return $multigroupnodes;
}

/**
 @brief retourne le code html d'incident
 @params array $param contient les paramètres de l'includeblock
 @params array $query liste des erreurs des services
 @params array $lang contient les traductions
 */

function CreateTabIncident($query,$lang,$param)
{
	foreach($query as $value)
	{
		if($value['error_type']=="unknown" && $param[affiche_unknown]==true)
		{
			createelementTab($param,$value,$lang);
		}
		elseif($value['error_type']=="warning" && $param[affiche_warning]==true)
		{
			createelementTab($param,$value,$lang);
		}
		elseif($value['error_type']=="critical" && $param[affiche_critical]==true)
		{
			createelementTab($param,$value,$lang);
		}
	}
}

function createelementTab($param,$value,$lang)
{
	$common_name = Model_esia::getCommonName($lang, $value['service_name'], $value['plugin_name']);
	$value['device_group_name'] = str_replace("\n", "</br>", $value['device_group_name']);

	echo '<tr>';
	if($param['affiche_groupNoeud']==true)
	{
		echo'<td><p style="word-wrap:break-word;line-height: 2;">'.$value['device_group_name'].'</p></td>';
	}
        echo'<td><p style="word-wrap:break-word">'.$value['device_name'].'</p></td>';
        if($param['affiche_technical_name']==true)
        {
                echo'<td><p style="word-wrap:break-word">'.$value['service_name'].'</p></td>';
        }
	if($param['affiche_ip']==true)
	{
		echo'<td><p style="word-wrap:break-word">'.$value['device_ip_addr'].'</p></td>';
	}
	echo'<td><p style="word-wrap:break-word;font-size:10px";>'.str_replace('_',' ',$common_name).'</p></td>';
	switch ($value['error_type'])
	{
		case 'warning':
			echo'<td><p class="EventWarning_Incident">'.$lang['REPORT_WARNING'].'</p></td>';
			break;
		case 'critical':
			echo'<td><p class="EventCritical_Incident">'.$lang['REPORT_CRITICAL'].'</p></td>';
			break;
		case 'unknown':
			echo'<td><p class="EventUnknown_Incident">'.$lang['REPORT_UNKNOWN'].'</p></td>';
			break;
	}
	if($param['affiche_message']==true)
	{
		echo'<td><p style="word-wrap:break-word;font-size:10px";>'.$value['happen_message'].'</p></td>';
	}
	$time = date_format(new DateTime($value['time']),'d/m/Y H:i:s');
	echo'<td><p style="word-wrap:break-word">'.$time.'</p></td>';
	if($param['affiche_time_end']==true)
	{
		$timeEnd = date_format(new DateTime($value['time_end']),'d/m/Y H:i:s');
		echo'<td><p style="word-wrap:break-word">'.$timeEnd.'</p></td>';
	}
	if($param['affiche_duree']==true)
	{
		echo'<td><p style="word-wrap:break-word">'.$value['during'].'</p></td>';
	}
	echo '</tr>';
}
/**
 @brief retourne la valeur associé à la clé
 @detail retourne la valeur associé au paramètre. ou une valeur par défaut
 @params array $options le tableau de paramètre global
 @params string $name1 le nom court du paramètre (ex: -H 127.0.0.1)
 @params string $name2 le nom long du paramètre (ex: --host 127.0.0.1)
 @params string $default (optionnel) la valeur par défaut du paramètre s'il n'est pas spécifié
 @retval	null|mixed la valeur du paramètre
 @throw void
 */
function getParam($options,$name1,$name2,$default=null)
{
	if( isset( $options[$name1] ) ) return $options[$name1];
	if( isset( $options[$name2] ) ) return $options[$name2];
	return $default;
}

?>
