<?php
if(empty($_SERVER['DOCUMENT_ROOT'])) 
{
	$is_cli=true;
	$_SERVER['DOCUMENT_ROOT']='/usr/local/esia/public_html/';
}

$path = rtrim ($_SERVER['DOCUMENT_ROOT'],'/');
include_once $path.'/esia.conf.php';
include_once $path.'/Model_esia.php';
include_once $path.'/Model_adm.php';
include_once $path.'/plugin/report/Model_Report.php';
include_once $path.'/libs/convert.lib.php';
$rrdpath='/usr/local/esia/public_html/data/rra/';
$ESIA_WIDGET_NOTREE=true;
$rrdpath=RRA_DIRECTORY;

if(!$is_cli)
{
	include_once '/usr/local/esia/public_html/common.php';
}
$SHORT_OPTS="a:i:s:e:l:";
$LONG_OPTS=array("action:","id:","start:","end:","language:");

if((isset($_POST['blockid']))&&!empty($_POST['blockid'])) // Lors de la modification du bloc
{
	$idInclude= $_POST['blockid'];
	$action= $_GET['action'];
}
elseif((isset($_GET['id'])) &&!empty($_GET['id'])) // Lors de l'ajout du bloc
{
	$idInclude=$_GET['id'];
	$action=$_GET['action'];
}
else // Lors de l'appel par repor_generate.php
{
	$options = getopt($SHORT_OPTS, $LONG_OPTS);
	
	$action	  = getParam($options,"action","a");
	$idInclude= getParam($options,"id","i");
	$start	  = getParam($options,"start","s");
	$end	  = getParam($options,"end","e");
	$language = getParam($options,"language","l");
	include $path.'/plugin/report/lang/'.$language.'.php';
	include $path.'/lang/'.$language.'/common_plugin_name.php';
	
	$datetime1 = new DateTime($start);
	$datetime2 = new DateTime($end);
	$today = new DateTime(date("Y-m-d"));
	$diff = $datetime1->diff($datetime2);
	$interval = $diff ->format('%a');

	$diff = $datetime2->diff($today);
	if($diff->format('%a')=="0") // Si date fin du rapport est plus grande ou equale à la date du jour
	{
		$dateFin = "N";		
	}
	else // Si choix de date manuel
	{				
		$dateFin = $diff ->format('%a');		
		$interval = $dateFin + $interval;
		$dateFin = "-".$dateFin."d";
	}
	$interval = "-".$interval."d";
	
	try
	{
		$dbconnection = new PDO('pgsql:host='.DB_HOST.';port='.DB_PORT.';dbname='.DB_NAME, DB_USERNAME, DB_PWD);
		$dbconnection->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_WARNING);
	}
	catch(Exception $e)
	{
		echo 'PDO SQL ERROR: '.$e->getMessage().'<br />';
		echo 'N° : '.$e->getCode();
	}
}

$query=Model_Report::getReportIncludeBlock($dbconnection,$idInclude);
$query= $query[0];

if($action=="generate")
{	
	$param = json_decode($query['include_parameter'],true);
	
	echo '<div class="clear"></div>';
	echo '<section class="blockView">
          	<div class="blockView_title">
          		<h3 style="text-align:'.$param['title']['style']['text-align'].';
						font-size:'.$param['title']['style']['font-size'].';
						color:'.$param['title']['style']['color'].'"
						><p>'.$param['title']['text'].'</p></h3>
        	</div>
        	<div class="pad">
          		<p style="text-align:'.$param['description']['style']['text-align'].';
						font-size:'.$param['description']['style']['font-size'].'"
							>'.$param['description']['text'].'</p>';
	echo '<table class="tab">
           	<thead>
             <tr valign="top">';
	
	if($param['affiche_groupNoeud']==true)
	{
		echo '<th><p style="word-wrap:break-word" >'.$lang['REPORT_DEVICE_GROUP_NAME'].'</p></th>';
	}
	echo '<th><p>'.$lang['REPORT_DEVICE_NAME'].'</p></th>';	
	if($param['affiche_ip']==true)
	{
		echo '<th><p style="word-wrap:break-word">'.$lang['REPORT_IP_ADD'].'</p></th>';
	}
	if($param['affiche_description']==true)
	{
		echo '<th><p style="word-wrap:break-word">'.$lang['REPORT_BLOCK_DESCRIPTION'].'</p></th>';
	}
	if($param['affiche_cpu']==true)
	{
		echo '<th><p style="word-wrap:break-word">CPU</p></th>';
		echo '<th><p style="word-wrap:break-word">'.$lang['REPORT_CPU'].'</p></th>';		
	}
	if($param['affiche_ram']==true)
	{
		echo '<th><p style="word-wrap:break-word">RAM</p></th>';
		echo '<th><p style="word-wrap:break-word">'.$lang['REPORT_RAM'].'</p></th>';
	}
	if($param['affiche_stockage']==true)
	{
		echo '<th><p style="word-wrap:break-word">'.$lang['REPORT_STOCKAGE_TOTAL'].'</p></th>';
		echo '<th><p style="word-wrap:break-word">'.$lang['REPORT_STOCKAGE_INSTALL'].'</p></th>';
		echo '<th><p style="word-wrap:break-word">'.$lang['REPORT_STOCKAGE_USED'].'</p></th>';
	}
	if($param['affiche_espaceLibre']==true)
	{
		echo '<th><p style="word-wrap:break-word">'.$lang['REPORT_DISK_FREE_SPACE'].'</p></th>';
	}
	echo '</tr></thead><tbody>';
	
	$tab_id_node = array();	
	if(is_null($user)==false)
	{
		$tab_id_node=nodeOrGroupNode($dbconnection,$param,$user->getId());
	}
	else
	{
		$report_user = Model_Report::getOwnerCanevas($dbconnection,$query['include_canevas_id']);
		$iduser = $report_user;
		$tab_id_node=nodeOrGroupNode($dbconnection,$param,$iduser[0]);
	}
	
	foreach ($tab_id_node as $i)
	{		
		$query = Model_Report::getUsageRessourceNode($dbconnection,$i['id']);
		if(!empty($query)&& $query!=null)
		{
			$elementTab = array();
			$elementTab['device_group_name']=$query[0]['device_group_name'];
			$elementTab['device_name']=$query[0]['device_name'];
			$elementTab['device_ip_addr']=$query[0]['device_ip_addr'];
			$elementTab['device_description']=$query[0]['device_description'];
			$stockage_total = 0;
			//echo '<pre>';print_r($query);
			foreach ($query as $elem)
			{
				if(preg_match("/LOAD/",$elem['plugin_name']) && $param['affiche_cpu']==true)
				{
					if(preg_match("/(\d+)\s+CPU/",$elem['service_last_stdout'],$matches)) // 1 CPU, load 11.0% < 80% : OK
					{
						$elementTab['device_vCPU']=$matches[1];								
						$elementTab['device_cpu_usage'] = average_service($dbconnection,$elem['service_id'],$interval,$dateFin,$rrdpath)['cpu'];
					}
					else
					{
						$elementTab['device_vCPU']="No Data";
						$elementTab['device_cpu_usage']=0;
					}					
				}
				elseif(preg_match("/STORAGE/",$elem['plugin_name']) && $param['affiche_stockage']==true)
				{										
					if(preg_match("/\/(\d+)MB/",$elem['service_last_stdout'],$matches)) //  /: 19%used(1399MB/7321MB) (<80%) : OK  // C:\ Label:TI31213800A Serial Number 76190076: 9%used(32160MB/371265MB) (<80%) : OK
					{
						$max=$matches[1];
						$max=round($max/1024,1);																					
						$stockage_total = $stockage_total+$max;
						preg_match("/(\S+):/",$elem['service_last_stdout'],$matches);
						$elementTab['device_stockage_installe'][]=$matches[1].":".$max."GB<br>";
						$elementTab['stockage_name'][] = $matches[1].":";
						$hdd = average_service($dbconnection,$elem['service_id'],$interval,$dateFin,$rrdpath);
						$elementTab['device_stockage_usage'][] = $hdd;
						//if
						//$stockage_total = $stockage_total + $hdd['total'];
						//print_r($elementTab['device_stockage_usage']);
					}
					else
					{
						$elementTab['device_stockage_installe']="No Data";
					}					
				}
				elseif((preg_match("/MEM/",$elem['plugin_name']) || preg_match("/RAM/",$elem['plugin_name'])) && $param['affiche_ram']==true)
				{
					if(preg_match("/\/(\d+)MB/",$elem['service_last_stdout'],$matches)) // Ram : 42% (102MB/242MB), Swap : 16% : ; OK
					{
						$max=$matches[1];
						$max=round($max/1024, 1);
						$elementTab['device_ram']=$max."GB";
						$elementTab['device_usage_ram'] = average_service($dbconnection,$elem['service_id'],$interval,$dateFin,$rrdpath)['ram'];	
						//print_r($elementTab['device_usage_ram']);
					}
					else
					{
						$elementTab['device_ram']="No Data";
						$elementTab['device_usage_ram']=0;
					}
				}
			}
			if($stockage_total==0)
			{
				$elementTab['device_stockage']="No Data";
			}
			else
			{
				$elementTab['device_stockage']=$stockage_total."GB";
			}			
			createelementTab($elementTab,$param);			
		}
		else
		{
			$node = Model_esia::InstanceNode($dbconnection,$i['id']);				
			echo "<tr><td colspan='11'><p>".$node->getName()." ".$lang['REPORT_NO_DATA']."</p></td></tr>";
		}
	}
	echo '</tbody></table></div></section>';
}
elseif($action=="update")
{
	$template_path = $path.'/plugin/report/templates';
	$param = json_decode($query['include_parameter'],true);
	include $path.'/plugin/report/lang/'.$user->getLang().'.php';
	$smarty->assign('l_rdiskfree',$lang['REPORT_DISK_FREE_SPACE']);
	$rightWriting=$_GET['writingright'];
	if(!isset($rightWriting))
	{
		$rightWriting=$_POST['writingright'];
	}
	$smarty->assign('rightWriting',$rightWriting);
	
	$smarty->assign('block',$query);
	$smarty->assign('param',$param);
	$taille = explode("px", $param['title']['style']['font-size']);
	$smarty->assign('TaillePoliceTitle',$taille[0]);
	$taille = explode("px", $param['description']['style']['font-size']);
	$smarty->assign('TaillePoliceDescr',$taille[0]);
	$smarty->assign('AlignTilte',$param['title']['style']['text-align']);
	$smarty->assign('AlignDesc',$param['description']['style']['text-align']);
	
	if(isset($_POST['blockid'])&&!empty($_POST['blockid']))
	{
		try
		{
			// Param Title
			$param['title']['text']=$_POST["blockname"];
			$TaillePoliceTitle = $_POST["namesize"];
			$param['title']['style']['font-size']=$TaillePoliceTitle."px";
			$param['title']['style']['text-align']=$_POST["nameposition"];
			$param['title']['style']['color']=$_POST["blockcolor"];
			
			// Param Descr
			$param['description']['text']=$_POST["blockdescription"];
			$TaillePoliceDescr=$_POST["blocksize"];
			$param['description']['style']['font-size']=$TaillePoliceDescr."px";
			$param['description']['style']['text-align']=$_POST["desciptionposition"];
		
			// Service & Noeud
			if ($param['type']=='noeud')
			{
				$param['nodeid']=$_POST['nodes'];
			}
			else
			{
				$param['groupnodeid']=$_POST['groupnodes'];;
			}			
			$param['affiche_groupNoeud']=$_POST['groupNoeud'];
			$param['affiche_espaceLibre']=$_POST['espacelibre'];
			// Seuil de Warning et Critical
			$param['SeuilWarningCpu']=$_POST['SeuilWarningCpu'];
			$param['SeuilCriticalCpu']=$_POST['SeuilCriticalCpu'];
			
			$param['SeuilWarningRam']=$_POST['SeuilWarningRam'];
			$param['SeuilCriticalRam']=$_POST['SeuilCriticalRam'];
			
			$param['SeuilWarningStorage']=$_POST['SeuilWarningStorage'];
			$param['SeuilCriticalStorage']=$_POST['SeuilCriticalStorage'];
		
			// Affichage colonne			
			$param['affiche_ip']=$_POST['add_ip'];					
			$param['affiche_cpu']=$_POST['cpu'];
			$param['affiche_description']=$_POST['descript'];
			$param['affiche_ram']=$_POST['ram'];
			$param['affiche_stockage']=$_POST['stockage'];

			$paramSave = json_encode($param);
		
			$query=Model_Report::getReportIncludeBlock($dbconnection,$_POST['blockid']);
			$query= $query[0];

			Model_Report::UpdtReportIncludeBlock($dbconnection,$_POST['blockid'],$query['include_block_id'],$query['include_canevas_id'],$query['include_position'],$paramSave);
			$smarty->assign('l_success',$lang['UPDATE_DASHBOARD_SUCCESS']);
		}
		catch (EsiaDbException $e)
		{
			$smarty->assign('l_error',$e->getMessage());
		}
		catch (Exception $e)
		{
			$smarty->assign('l_error',$e->getMessage());
		}
		
		$smarty->assign('block',$query);
		$smarty->assign('param',$param);
		$taille = explode("px", $param['title']['style']['font-size']);
		$smarty->assign('TaillePoliceTitle',$taille[0]);
		$taille = explode("px", $param['description']['style']['font-size']);
		$smarty->assign('TaillePoliceDescr',$taille[0]);
		$smarty->assign('AlignTilte',$param['title']['style']['text-align']);
		$smarty->assign('AlignDesc',$param['description']['style']['text-align']);
	}
		
	$listnode = array();
	//Récupération des services
	if($param['type']=="noeud")
	{
		//Récupération des noeuds
		$nodes = Model_esia::getNodeList($dbconnection,$user->getId(),null,Model_esia::NODE_INSTANCE);
		$list=array();
		foreach($nodes as $node)
		{
			$selected='no';
			if(in_array($node->getId(),$param['nodeid']))
			{
				$selected='yes';
			}
			$list[]=array('id'=>$node->getId(),
					'name'=>$node->getGroup().'>'.$node->getName(),
					'selected'=>$selected
						
			);
		}
	}
	else
	{
		$list = Model_esia::getNodeGroupHierarchyByUser($dbconnection,$user->getId());
		$list_group_node=array();
		foreach($list as $node)
		{
			$selected='no';
			if(in_array($node['id'],$param['groupnodeid']))
			{
				$selected='yes';
			}
				
			$list_group_node[]=array('id'=>$node['id'],
					'name'=>$node['name'],
					'selected'=>$selected);
		}		
	}
	$smarty->assign('adm_list_node', $list);
	$smarty->assign('adm_list_group_node', $list_group_node);
	$smarty->assign('action','update');
	$smarty->display($template_path.'/useResources.html');
}
elseif($action =="getservice")
{
	$template_path = $path.'/plugin/report/templates';
	if(isset($_GET['nodeid']))
	{
		$tablenodeid = json_decode($_GET['nodeid']);
		$list=array();
		foreach($tablenodeid as $nodeid)
		{
			$node = Model_esia::InstanceNode($dbconnection, $nodeid);
			if($user->getAccess($dbconnection, "device_view",$node->getName())==1)
			{
				$services = Model_esia::getServices($dbconnection,$node->getId());
				foreach ($services as $service)
				{
					$common_name = Model_esia::getCommonName($lang, $service['name'],$service['check_plugin_name']);
					$list[$service['id']]=$node->getName().' > '.$common_name;
				}
			}
		}
		echo json_encode($list);
		exit(0);
	}
}

/**
 * @brief fais la difference entre noeud et groupe de noeud et retourne les bons param's
 * @detail retourne un array contenant les paramètres utlisés qu'importe que ce soit un noeud ou groupe de noeud
 * @param PDO $dbconnection
 * @param array $param contient les param du block
 * @retval unknown[][]|NULL[][]
 * @throw void
 */

function nodeOrGroupNode($dbconnection,$param,$userid)
{
	$tab_id_node=array();
	if($param['type']=="noeud")
	{
		foreach($param['nodeid'] as $val)
		{
			$tab_id_node[] = array('id'=>$val);
		}
	}
	else
	{
		foreach ($param['groupnodeid'] as $groupnode )
		{
			$tab_group_node = Model_esia::getAllNodeofGroup($dbconnection,$userid,$groupnode);
			//$tab_group_node = Model_esia::getNodeList($dbconnection,null,$groupnode,$t_return = Model_esia::NODE_INSTANCE);
			foreach ($tab_group_node as $node)
			{
				$tab_id_node[] = array('id'=>$node->getId(),'parent'=>$node->getGroup(),'idgroup'=>$node->getGroupId());
			}
		}
	}
	return $tab_id_node;
}

function createelementTab($value,$param)
{	
	echo '<tr>';
	if($param['affiche_groupNoeud']==true)
	{
		echo'<td><p style="word-wrap:break-word">'.$value['device_group_name'].'</p></td>';
	}
	echo'<td><p style="word-wrap:break-word">'.$value['device_name'].'</p></td>';
	if($param['affiche_ip']==true)
	{
		echo'<td><p style="word-wrap:break-word">'.$value['device_ip_addr'].'</p></td>';
	}
	if($param['affiche_description']==true)
	{
		echo'<td><p style="word-wrap:break-word">'.$value['device_description'].'</p></td>';
	}
	if($param['affiche_cpu']==true)
	{
		echo'<td><p style="word-wrap:break-word">'.$value['device_vCPU'].'</p></td>'; // vCPU
		if($param['SeuilCriticalCpu']<=$value['device_cpu_usage'])
		{			
			echo'<td><p class="EventCritical_Incident" style="word-wrap:break-word">'.$value['device_cpu_usage'].'%</p></td>'; // CPU usage
		}
		elseif($param['SeuilWarningCpu']<=$value['device_cpu_usage'])
		{
			echo'<td><p class="EventWarning_Incident" style="word-wrap:break-word">'.$value['device_cpu_usage'].'%</p></td>'; // CPU usage
		}
		else
		{
			echo'<td><p style="word-wrap:break-word">'.$value['device_cpu_usage'].'%</p></td>'; // CPU usage
		}
	}
	if($param['affiche_ram']==true)
	{
		echo'<td><p style="word-wrap:break-word">'.$value['device_ram'].'</p></td>'; // RAM
		if($param['SeuilCriticalRam']<=$value['device_usage_ram'])
		{
			echo'<td><p class="EventCritical_Incident" style="word-wrap:break-word">'.$value['device_usage_ram'].'%</p></td>'; // RAM usage
		}
		elseif($param['SeuilWarningRam']<=$value['device_usage_ram'])
		{
			echo'<td><p class="EventWarning_Incident" style="word-wrap:break-word">'.$value['device_usage_ram'].'%</p></td>'; // RAM usage
		}
		else
		{
			echo'<td><p style="word-wrap:break-word">'.$value['device_usage_ram'].'%</p></td>'; // RAM usage
		}		
	}
	if($param['affiche_stockage']==true)
	{
		echo'<td><p style="word-wrap:break-word">'.$value['device_stockage'].'</p></td>'; // Stockage Total	
		echo '<td>';
		if(!empty($value['device_stockage_installe']))
		{
			foreach ($value['device_stockage_installe'] as $val)
			{
				echo'<p style="word-wrap:break-word">'.$val.'</p>';
			}
		}
		echo '</td>';
		
		echo '<td>';
		$i=0;
		if(!empty($value['device_stockage_usage']))
		{
			foreach ($value['device_stockage_usage'] as $val)
			{
				$disk=$value['stockage_name'][$i];
				if($param['SeuilCriticalStorage']<=$val['hdd'])
				{			
					echo'<p class="EventCritical_Incident" style="word-wrap:break-word">'.$disk.''.$val['hdd'].'%</p>'; // Stockage usage
				}
				elseif($param['SeuilWarningStorage']<=$val['hdd'])
				{
					echo'<p class="EventWarning_Incident" style="word-wrap:break-word">'.$disk.''.$val['hdd'].'%</p>'; // Stockage usage
				}
				else
				{
					echo'<p style="word-wrap:break-word">'.$disk.''.$val['hdd'].'%</p>'; // Stockage usage
				}	
				$i++;
			}
		}
		echo '</td>';
	}
	if($param['affiche_espaceLibre']==true)
	{		
		echo '<td>';
		$i=0;
		if(!empty($value['device_stockage_usage']))
		{
			foreach ($value['device_stockage_usage'] as $val)
			{
				$disk=$value['stockage_name'][$i];
				//echo $val['total']-$val['used'];
				$free = Convert\bytes($val['total']-$val['used']);
				echo'<p style="word-wrap:break-word">'.$free['value'].' '.$free['unity'].'</p>'; // Stockage usage
				$i++;
			}
		}
		echo '</td>';
	}
	echo '</tr>';
}
/**
 @brief retourne la valeur associé à la clé
 @detail retourne la valeur associé au paramètre. ou une valeur par défaut
 @params array $options le tableau de paramètre global
 @params string $name1 le nom court du paramètre (ex: -H 127.0.0.1)
 @params string $name2 le nom long du paramètre (ex: --host 127.0.0.1)
 @params string $default (optionnel) la valeur par défaut du paramètre s'il n'est pas spécifié
 @retval	null|mixed la valeur du paramètre
 @throw void
 */
function getParam($options,$name1,$name2,$default=null)
{
	if( isset( $options[$name1] ) ) return $options[$name1];
	if( isset( $options[$name2] ) ) return $options[$name2];
	return $default;
}

/**
 @brief retourne la valeur en % moyenne du service
 @detail retourne en pourcentage la valeur du service
 @params int $service_id l'identifiant du service
 @params string $interval nombre de jour de décalage (ex: -30d)
 @params string $dateFin Soit N si c'est aujourd'hui ou alors -'x'd  (x = valeur nombre de jour)
 @params string $rrdpath path pour les rrd
 @retval	int la valeur du service (%)
 @throw void
 */

function average_service($dbconnection,$service_id,$interval,$dateFin,$rrdpath)
{
	$query= $dbconnection->prepare("SELECT service_id,service_name,service_parameter,service_last_stdout,device_name,plugin_name,
								rrd_type,rrd_regex,rrd_time,rrd_name,rrd_max,rrd_min,rrd_vertical_label,rrd_graph_color,rrd_graph_type,rrd_regex_threshold,rrd_graph_num
							FROM esia_services
							JOIN esia_device ON device_id = service_device_id
							JOIN esia_plugins ON plugin_id = service_plugin_id
							JOIN rrd_plugins ON rrd_plugin_id=service_plugin_id WHERE service_id=? ORDER BY rrd_graph_type,rrd_name;");
	$ret = $query->execute(array($service_id));
	if($ret===false)
	{
		$err = $query->errorInfo();
		echo "DB error: ".$err[2]."\n";
	}
	$arr_rrd=$query->fetchAll(PDO::FETCH_OBJ);
	//liste les information pour générer le graphique et les sépares suivant leurs numéros (clé rrd_graph_num)
	$list_file=array();
	$data = array();
	foreach($arr_rrd as $row)
	{
		$filename = $rrdpath.$row->device_name.'_'.$row->plugin_name.$row->service_id.$row->rrd_graph_num.'.rrd';
		if(is_file($filename) && !in_array($filename, $list_file))
		{
			$list_file[]=$filename;					
			$ret = rrd_fetch($filename, array( "AVERAGE", "--start",$interval, "--end",$dateFin));
			if(preg_match('#STORAGE#',$row->plugin_name))
			{
				foreach($ret['data'] as $key => $rrddata)
				{
					$flag = false;
					$val = '';
					while($flag == false && ($value = array_pop($rrddata))!==NULL )
					{
						if(stristr($value,'NAN')==FALSE)
						{
							$flag ==true;
							$val =  floatval($value);
						}
					}
					$data[strtolower($key)]=round($val,1);
				}
			}
			else 
			{
				foreach($ret['data'] as $key => $rrddata)
				{
					$i=0;
					$avg=0;
					foreach($rrddata as $value)
					{
						if(stristr($value,'NAN')==FALSE)
						{
							
							$avg = $avg + floatval($value);
							$i++;
						}
					}
					if($i !=0)
					{
						$avg=round($avg/$i,2);
					}
					else
					{
						$avg='';
					}
					$data[strtolower($key)]=$avg;
				}
				
			}
		}
	}
	return $data;
}
function formatBytes($bytes, $precision = 2) {
	$units = array('', 'KB', 'MB', 'GB', 'TB');
	$base = log($bytes, 1024);
	return round(pow(1024, $base - floor($base)), $precision) .' '. $units[floor($base)];
} 
?>
